<template lang="pug">
#app
    <HEADER />
    b-button.addComponent(@click="toggleSidebar")
    <b-sidebar v-model="sidebar_visible" id="sidebar-1" title="" no-header right>
        <draggable v-model="primaryComponent" id="componentList" class="list-group componentList" animation="150" drag-class="dragComponent" ghost-class="ghostComponent" :group="{ name: 'shared', pull: 'clone', put: false }" :sort="false" :clone="onClone">
            <b-list-group-item class="componentItem" :key="item.id" v-for="(item, index) in primaryComponent">
                b-img.componentItem_img(
                    :src="require(`@/assets/png/${item.name}.jpg`)"
                )
            </b-list-group-item>
        </draggable>
    </b-sidebar>
    <draggable v-model="secondaryComponent" :setData="setData" id="componentList2" class="list-group componentList" drag-class="dragComponent" ghostClass="ghostComponent" :group="{ name: 'shared' }" animation="150" handle="">
        <b-list-group-item class="componentItem" :class="`componentItem${item.id}`" :key="item.id" v-for="(item, index) in secondaryComponent">
            DEFAULT(
                path="edit",
                :tabindex="index",
                :componentName="item.name",
                :item="item",
                :link="item.link",
                :ref="item.unit_type + item.id",
                :ref-name="item.name + item.id"
            )
        </b-list-group-item>
    </draggable>
</template>

<script>
//vuex
import {
    mapGetters
} from "vuex";
//comp
import draggable from "vuedraggable";
import DEFAULT from "@/components/template/T-default";
import HEADER from "@/components/header/header";
export default {
    data() {
        return {
            idGlobal: 5,
            sidebar_visible: false,
        };
    },
    computed: {
        ...mapGetters({}),
        primaryComponent: {
            get() {
                return this.$store.state.primaryComponent;
            },
            set(value) {
                this.$store.commit("UPDATE_PRIMARYCOMPONENT", value);
            },
        },
        secondaryComponent: {
            get() {
                return this.$store.state.secondaryComponent;
            },
            set(value) {
                this.$store.commit("UPDATE_SECONDARYCOMPONENT", value);
            },
        },
    },
    methods: {
        toggleSidebar() {
            this.sidebar_visible = !this.sidebar_visible;
            $(".addComponent").toggleClass("active");
        },
        setData(dataTransfer, dragEl) {
            dataTransfer.setData("Text", "");
        },
        onClone(evt) {
            this.toggleSidebar();
            this.idGlobal++;
            return {
                name: evt.name,
                id: evt.id + this.idGlobal,
                link: evt.link,
                content: evt.content,
            };
        },
    },
    components: {
        HEADER,
        draggable,
        DEFAULT,
    },
    mounted() {
        this.idGlobal = this.primaryComponent.length + 1;

        this.$store.dispatch("getTemplate", 1);
    },
    created() {},
};
</script>

<style lang="scss">
#app {
    display: flex;
    flex-wrap: wrap;
    justify-content: center;
    background-color: #eff1f2;
    overflow-x: scroll;
    min-width: 1440px;
}

#componentList2 {
    width: 60%;
    min-height: 160vh;
    overflow: initial;
    margin-top: 40px;
    background-color: white;
    margin-top: 100px;
    transform: translateX(-50px);

    .componentItem {
        padding: 0.75rem;
        transition: all 0.1s ease-in-out;

        &.selected {
            border: 3px solid;
            border-color: #17a2b8;
        }
    }
}

#componentList {
    background-color: #d8d8d8;
    padding: 10px;
    padding-right: 20px;
    border-radius: 0;
    box-shadow: 0 0 5px rgba(0, 0, 0, 0.2);
    padding-top: 70px;

    .componentItem {
        margin-bottom: 15px;
        box-shadow: 0 0 5px rgba(0, 0, 0, 0.2);
        padding: 0.2rem;

        img {
            max-width: 100%;
        }
    }

    .tool {
        display: none;
    }
}

.addComponent {
    position: fixed;
    width: 60px;
    height: 60px;
    top: 90px;
    right: 0;
    transition: all 0.33s ease-in-out;
    border: none;
    border-radius: 50%;
    border-color: transparent;
    background-color: #d8d8d8;
    padding: 32px;
    transform: translateX(22px);
    z-index: 30;

    &:active,
    &:hover,
    &:focus {
        border: none !important;
        box-shadow: none !important;
        background-color: #d8d8d8 !important;
    }

    &.active {
        right: 320px;
        background-color: #d8d8d8 !important;
    }
}

.componentList {
    width: 100%;
    height: 100%;
}

.component {
    position: relative;
    height: auto;
}

.dragComponent {
    position: relative;
    background: #fff;
    border: 4px solid rgba($color: #000000, $alpha: 0.6);
    width: 250px;
    height: auto;
    z-index: 92;

    .componentItem_img {
        opacity: 0.5;
    }

    .component {
        opacity: 0;
    }
}

.ghostComponent {
    position: relative;
    background-color: #fff;
    border: 4px dashed rgba($color: #000000, $alpha: 0.6);
    width: 100%;
    height: auto;
    z-index: 90;

    .componentItem_img {
        opacity: 0;
    }

    .component {
        opacity: 0;
    }
}

div,
[contentEditable="true"],
li,
.ProseMirror>p {
    &:focus {
        outline: transparent auto 0;
    }
}

.modal-dialog {
    box-shadow: 0 5px 15px rgba(0, 0, 0, 0.5);
    margin: 11.75rem auto;
}
</style>
